;Aufbau der LCD Zeilen (24 Pixelreihen) und Speicherung jeder Pixelreihe im SRAM

Zeile_1:								;1. Zeile = Leerzeile 

Zeile_2:								;2. Zeile = Wochentag + "den"
	lds		Wert_akt, Wtag_akt			;aktuellen Wochentag abrufeb
	dec		Wert_akt
	rcall	W_tag_Wahl
	ldi		X_off,2						;2 Leerbytes
	mov		temp, X_lang
	mul		temp, C_Cnt
	add		ZL, r0
	adc		ZH, r1	

	rcall	Text						;Fllen des SRAM

	clr		Wert_akt
	ldi		temp, 4
	add		X_lang, temp
	mov		X_off,X_lang
	ldi		X_lang,6
	mov		temp, X_lang
	offset	
	ldi		ZL, LOW(den)		
	ldi		ZH, HIGH(den)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text						;Fllen des SRAM

	rjmp 	exit_int


Zeile_3:								;3. Zeile = obere Hlfte der Jahreszahl 
	rcall	Leer
	clr		Wert_akt
	ldi		X_off,26
	ldi		X_lang,3
	ldi		temp, 4
	offset
	ldi		ZL, LOW(Jahr_St+2*Jahr_)				; Datenblock Jahr_Tausenderstelle (2)
	ldi		ZH, HIGH(Jahr_St+2*Jahr_)
	add		ZL, r2
	adc		ZH, r3	

	rcall	Text

	clr		Wert_akt
	ldi		X_off,29
	ldi		X_lang,3
	ldi		temp, 4
	offset	
	ldi		ZL, LOW(Jahr_St)			;Datenblock Jahr_Hunderterstelle (0)
	ldi		ZH, HIGH(Jahr_St)
	add		ZL, r2
	adc		ZH, r3	

	rcall	Text

	lds		Wert_akt, Jahr_Z			;Datenblock Jahr_Zehnerstelle
	ldi		ZL, LOW(Jahr_)			
	ldi		ZH, HIGH(Jahr_)
	ldi		X_off,32
	ldi		X_lang,3
	ldi		temp, 4
	offset
	ldi		ZL, LOW(Jahr_St)		
	ldi		ZH, HIGH(Jahr_St)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	lds		Wert_akt, Jahr_E			;Datenblock Jahr_Einerstelle
	ldi		ZL, LOW(Jahr_)			
	ldi		ZH, HIGH(Jahr_)
	ldi		X_off,35
	ldi		X_lang,3
	ldi		temp, 4
	offset
	ldi		ZL, LOW(Jahr_St)		
	ldi		ZH, HIGH(Jahr_St)
	add		ZL, r2
	adc		ZH, r3		
	
	rcall	Text

	rjmp 	exit_int

Zeile_4:								;4. Zeile = Tag + Punkt + Monat + untere Hlfte Jahreszahl
	lds		Wert_akt, Dat_Z				;Datenblock Tag_Zehnerstelle
	ldi		ZL, LOW(Dat_)			
	ldi		ZH, HIGH(Dat_)
	ldi		X_off,2						;2 Leerbytes
	ldi		X_lang,2
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Dat_St+10)		
	ldi		ZH, HIGH(Dat_St+10)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	lds		Wert_akt, Dat_E				;Datenblock Tag_Einerstelle
	ldi		ZL, LOW(Dat_)			
	ldi		ZH, HIGH(Dat_)
	ldi		X_off,4
	ldi		X_lang,2
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Dat_St+10)		
	ldi		ZH, HIGH(Dat_St+10)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	clr		Wert_akt
	ldi		X_off,6
	ldi		X_lang,2
	mov		temp, X_lang
	offset	
	ldi		ZL, LOW(Punkt)		
	ldi		ZH, HIGH(Punkt)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text						;Fllen des SRAM

	lds		Wert_akt, Mon_akt			;Datenblock Monat
	dec		Wert_akt
	rcall	Mon_Wahl
	ldi		X_off, 8
	mov		temp, X_lang				;Faktor zur Berechnung des Z_off der nchsten Pixelreihe
	mul		temp, C_Cnt
	add		ZL, r0
	adc		ZH, r1	

	rcall	Text

	clr		Wert_akt
	ldi		X_off,26
	ldi		X_lang,3
	ldi		temp, 4
	offset	
	ldi		ZL, LOW(Jahr_St+2*Jahr_+96)				; Datenblock Jahr_Tausenderstelle 
	ldi		ZH, HIGH(Jahr_St+2*Jahr_+96)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	clr		Wert_akt
	ldi		X_off,29
	ldi		X_lang,3
	ldi		temp, 4
	offset
	ldi		ZL, LOW(Jahr_St+96)			;Datenblock Jahr_Hunderterstelle
	ldi		ZH, HIGH(Jahr_St+96)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	lds		Wert_akt, Jahr_Z			;Datenblock Jahr_Zehnerstelle
	ldi		ZL, LOW(Jahr_)			 
	ldi		ZH, HIGH(Jahr_)
	ldi		X_off,32
	ldi		X_lang,3
	ldi		temp, 4
	offset
	ldi		ZL, LOW(Jahr_St+96)	 
	ldi		ZH, HIGH(Jahr_St+96)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	lds		Wert_akt, Jahr_E			;Datenblock Jahr_Einerstelle 
	ldi		ZL, LOW(Jahr_)			
	ldi		ZH, HIGH(Jahr_)
	ldi		X_off,35
	ldi		X_lang,3
	ldi		temp, 4
	offset
	ldi		ZL, LOW(Jahr_St+96)	
	ldi		ZH, HIGH(Jahr_St+96)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	rjmp 	exit_int

Zeile_5:								;5. Zeile = Leerzeile
	rcall	Leer

	rjmp 	exit_int

Zeile_6:								;6. Zeile = oberes Drittel von Stunden + Doppelpunkt + Minuten
	lds		Wert_akt, Std_Z				;Datenblock Stunden_Zehnerstelle
	ldi		ZL, LOW(Zeit_)			
	ldi		ZH, HIGH(Zeit_)
	ldi		X_off,4
	ldi		X_lang,6
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Zeit_St)		
	ldi		ZH, HIGH(Zeit_St)
	add		ZL, r2
	adc		ZH, r3

	rcall	Text

	lds		Wert_akt, Std_E				;Datenblock Stunden_Einerstelle 
	ldi		ZL, LOW(Zeit_)			
	ldi		ZH, HIGH(Zeit_)
	ldi		X_off,10
	ldi		X_lang,6
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Zeit_St)		
	ldi		ZH, HIGH(Zeit_St)
	add		ZL, r2
	adc		ZH, r3

	rcall	Text

	clr		Wert_akt
	ldi		X_off,16
	ldi		X_lang,6
	mov		temp, X_lang
	offset	
	ldi		ZL, LOW(Doppelpunkt)		;Datenblock Doppelpunkt
	ldi		ZH, HIGH(Doppelpunkt)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	lds		Wert_akt, Min_Z				;Datenblock Minuten_Zehnerstelle 
	ldi		ZL, LOW(Zeit_)			
	ldi		ZH, HIGH(Zeit_)
	ldi		X_off,22
	ldi		X_lang,6
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Zeit_St)		
	ldi		ZH, HIGH(Zeit_St)
	add		ZL, r2
	adc		ZH, r3

	rcall	Text

	lds		Wert_akt, Min_E				;Datenblock Minuten_Einerstelle 
	ldi		ZL, LOW(Zeit_)			
	ldi		ZH, HIGH(Zeit_)
	ldi		X_off,28
	ldi		X_lang,6
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Zeit_St)		
	ldi		ZH, HIGH(Zeit_St)
	add		ZL, r2
	adc		ZH, r3

	rcall	Text

	rjmp 	exit_int

Zeile_7:								;7. Zeile = mittleres Drittel von Stunden + Doppelpunkt + Minuten
	lds		Wert_akt, Std_Z				;Datenblock Stunden_Zehnerstelle 
	ldi		ZL, LOW(Zeit_)			
	ldi		ZH, HIGH(Zeit_)
	ldi		X_off,4
	ldi		X_lang,6
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Zeit_St+144)	
	ldi		ZH, HIGH(Zeit_St+144)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	lds		Wert_akt, Std_E				;Datenblock Stunden_Einerstelle
	ldi		ZL, LOW(Zeit_)			
	ldi		ZH, HIGH(Zeit_)
	ldi		X_off,10
	ldi		X_lang,6
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Zeit_St+144)	
	ldi		ZH, HIGH(Zeit_St+144)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	clr		Wert_akt
	ldi		X_off,16
	ldi		X_lang,6
	mov		temp, X_lang
	offset	
	ldi		ZL, LOW(Doppelpunkt+144)	;Datenblock Doppelpunkt
	ldi		ZH, HIGH(Doppelpunkt+144)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	lds		Wert_akt, Min_Z				;Datenblock Minuten_Zehnerstelle
	ldi		ZL, LOW(Zeit_)			
	ldi		ZH, HIGH(Zeit_)
	ldi		X_off,22
	ldi		X_lang,6
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Zeit_St+144)	
	ldi		ZH, HIGH(Zeit_St+144)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	lds		Wert_akt, Min_E				;Datenblock Minuten_Einerstelle
	ldi		ZL, LOW(Zeit_)			
	ldi		ZH, HIGH(Zeit_)
	ldi		X_off,28
	ldi		X_lang,6
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Zeit_St+144)	
	ldi		ZH, HIGH(Zeit_St+144)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	rjmp 	exit_int

Zeile_8:								;8. Zeile = unteres Drittel von Stunden + Doppelpunkt + Minuten
	lds		Wert_akt, Std_Z				;Datenblock Stunden_Zehnerstelle
	ldi		ZL, LOW(Zeit_)			
	ldi		ZH, HIGH(Zeit_)
	ldi		X_off,4
	ldi		X_lang,6
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Zeit_St+288)	
	ldi		ZH, HIGH(Zeit_St+288)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	lds		Wert_akt, Std_E				;Datenblock Stunden_Einerstelle
	ldi		ZL, LOW(Zeit_)			
	ldi		ZH, HIGH(Zeit_)
	ldi		X_off,10
	ldi		X_lang,6
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Zeit_St+288)	
	ldi		ZH, HIGH(Zeit_St+288)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	clr		Wert_akt
	ldi		X_off,16
	ldi		X_lang,6
	mov		temp, X_lang
	offset	
	ldi		ZL, LOW(Doppelpunkt+288)	;Datenblock Doppelpunkt
	ldi		ZH, HIGH(Doppelpunkt+288)
	add		ZL, r2
	adc		ZH, r3		

	rcall	Text

	lds		Wert_akt, Min_Z				;Datenblock Minuten_Zehnerstelle
	ldi		ZL, LOW(Zeit_)			
	ldi		ZH, HIGH(Zeit_)
	ldi		X_off,22
	ldi		X_lang,6
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Zeit_St+288)	
	ldi		ZH, HIGH(Zeit_St+288)
	add		ZL, r2
	adc		ZH, r3

	rcall	Text

	lds		Wert_akt, Min_E				;Datenblock Minuten_Einerstelle
	ldi		ZL, LOW(Zeit_)			
	ldi		ZH, HIGH(Zeit_)
	ldi		X_off,28
	ldi		X_lang,6
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Zeit_St+288)	
	ldi		ZH, HIGH(Zeit_St+288)
	add		ZL, r2
	adc		ZH, r3

	rcall	Text

	rjmp 	exit_int

Zeile_9:								;9. Zeile = Sekunden
	rcall	Leer
	lds		Wert_akt, Sek_Z				;Datenblock Sekunden_Zehnerstelle
	ldi		ZL, LOW(Sek_)			
	ldi		ZH, HIGH(Sek_)
	ldi		X_off,27
	ldi		X_lang,2
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Sek_St)		
	ldi		ZH, HIGH(Sek_St)
	add		ZL, r2
	adc		ZH, r3

	rcall	Text

	lds		Wert_akt, Sek_E				;Datenblock Sekunden_Einerstelle
	ldi		ZL, LOW(Sek_)			
	ldi		ZH, HIGH(Sek_)
	ldi		X_off,29
	ldi		X_lang,2
	mov		temp, X_lang
	offset
	ldi		ZL, LOW(Sek_St)		
	ldi		ZH, HIGH(Sek_St)
	add		ZL, r2
	adc		ZH, r3

	rcall	Text

	rjmp 	exit_int

Zeile_10:								;10. Zeile = Leerzeile
	rcall	Leer

	rjmp 	exit_int

;*******************************************************************
Leer:									;Leerschleife fr SRAM
	ldi 	temp, XSize
	mov 	X_Cnt, temp

Leerloop:											
	ldi		temp, 0x00		
	st		X+,temp
	dec		X_Cnt
	brne	Leerloop
	ldi		XL, low(Inhalt)			
	ldi		XH, high(Inhalt)
	ret

;********************************************************************
Text:									;Datenblcke aus Flash laden
	add		XL, X_off
	mov 	X_Cnt, X_lang

Text_loop:								
	lpm										
	mov		temp, r0
	adiw	ZL,1					
	st		X+,temp
	dec		X_Cnt
	brne	Text_loop
	ldi		XL, low(Inhalt)			
	ldi		XH, high(Inhalt)
	ret



.INCLUDE "Zeile_WTage.asm"

.INCLUDE "Zeile_Monate.asm"
